#include <stdio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define FILENAME "purple_full.bmp"

int main()
{
    g_type_init();
    
    GError* error = NULL;
    GIOChannel *channel = g_io_channel_new_file(FILENAME, "r", &error);
    if(channel == NULL)
    {
        printf("Cannot open file '%s' for read: %s.\n", FILENAME, error->message);
        return 1;
    }
    g_io_channel_set_encoding(channel, NULL, NULL);
    
    gsize buffer_length = 0;
    guchar* buffer = NULL;
    
    g_io_channel_read_to_end(channel, (char**)&buffer, &buffer_length, NULL);
    g_io_channel_unref(channel);
    //
    GdkPixbufLoader* loader = gdk_pixbuf_loader_new_with_type("bmp", NULL);
    gdk_pixbuf_loader_set_size(loader, 50, 50);
    
    gdk_pixbuf_loader_write(loader, buffer, buffer_length, NULL);
    g_free(buffer);
    
    GdkPixbuf *pixbuf1 = gdk_pixbuf_loader_get_pixbuf(loader);
    if(pixbuf1 == NULL)
    {
        printf("gdk_pixbuf_loader_get_pixbuf() returns NULL when be called first time.\n");
        return 1;
    }

    gdk_pixbuf_save(pixbuf1, "pixbuf1.bmp", "bmp", NULL, NULL);
    ////
    gdk_pixbuf_loader_close(loader, NULL);
    ////
    GdkPixbuf *pixbuf2 = gdk_pixbuf_loader_get_pixbuf(loader);
    if(pixbuf2 == NULL)
    {
        printf("gdk_pixbuf_loader_get_pixbuf() returns NULL when be called second time.\n");
        g_object_unref(loader);
        return 1;
    }

    gdk_pixbuf_save(pixbuf2, "pixbuf2.bmp", "bmp", NULL, NULL);
    
    printf("First call of gdk_pixbuf_loader_get_pixbuf() returns %p, second - %p.\n",
        pixbuf1, pixbuf2);

    g_object_unref(loader);

    return 0;
}